#pragma once
#include <type_traits>
#include <memory>

template <class T> //T je tip GPU kopije i u principu želimo da je jednaka glavnom (originalnom) tipu; P je struktura u T koja mora sadržavati samo sve njene podatke i ništa više
class GPUCopyable
{
 public:
  
  //GPUResident(bool naGPU) : naGPU(naGPU){}
  //GPUResident() = default;
  GPUCopyable() = default;
  GPUCopyable(const GPUCopyable &g2){}
  GPUCopyable(GPUCopyable &&g2) = default;
  GPUCopyable &operator=(const GPUCopyable &g2){}
  GPUCopyable &operator=(GPUCopyable &&g2) = default;
  ~GPUCopyable() = default;
   
  //virtual std::shared_ptr<T> PrekopirajNaGPU() //UVJET: korisnik mora pozvati ovu nadmetodu pri nadjačavanju u podklasi, na početku nove (pod)metode!
  T PrekopirajNaGPU(){}
    //gpuKopija = std::make_shared<T>(*this); //očekuje se da je T konstruktibilan od originalnog ekvivalentnog host tipa

    //stvarno kopiranje (po potrebi) obavlja korisnik u podklasi

 private:
  //  std::shared_ptr<T> gpuKopija;

 protected:
  
};
