#pragma once
#include "MatBaza.h"
#include "Objekt.h"
#include "Trokut.h"

class Kvadar : public Objekt
{
    public:
        Kvadar() = default;
        Kvadar(Realan,Realan,Realan,RGB boja=RGB(255u, 128u, 0u));
        virtual ~Kvadar() = default;

        void Transformiraj() override;

        bool PresijeciZraku(const Zraka &zraka,Realan &t) override;
        //bool PresijeciZraku(const Kamera &,const Zraka &zraka,double &t) override;
        RGB Sjencaj(const std::forward_list<Svjetlo *> &) override;
    protected:
    private:
    //Vektor3 v1, v2, v3, v4, v5, v6, v7, v8;//8 vrhova
    Trokut t[12];//12 trokuta (6 stranica)
    int presjecenTrokut = -1;
    Realan a, b, c;
    //Vektor3 kd = {1.0, 0.5, 0};
};
