#pragma once
#include "RGB.h"
#include "MatBaza.h"
#include <cstdint>

struct Materijal
{
  std::string naziv;
  RGB ka, kd = {1.0f, 0.5f, 0.5f}, ks, ns;
  Realan prozirnost;

  bool fresnel;
  bool sjene;
  bool refleksije;

  ///Tekstura ta, td, ts, talpha, tbump;
};

struct Tekstura
{
  uint16_t sirina, visina;
  Uint32 *tekseli;
  Vektor3 ishodiste;
  Vektor3 skala;
  Vektor3 turbulencija;
  bool clamp;
};
