#pragma once
#include "Matrica4x4.h"
#include "Svjetlo.h"
#include "Kamera.h"
#include "Zraka.h"
#include "RGB.h"
#include <forward_list>

class Objekt
{
 protected:
  Vektor3 sjeciste;

 public:
  Matrica4x4 transformacija = Matrica4x4::Jedinicna();
  virtual void Transformiraj() = 0;

  Objekt() = default;
  ~Objekt() = default;

  //  const Matrica4x4 &Transformacija() const;//opasno
  //  void PostaviTransformaciju(const Matrica4x4 &);

  virtual RGB Sjencaj(const std::forward_list<Svjetlo *> &svjetla) = 0;
  virtual bool PresijeciZraku(const Zraka &zraka,Realan &t) = 0;
  //virtual bool PresijeciZraku(const Kamera &,const Zraka &zraka,double &t) = 0;
};
