#pragma once
#include "MatBaza.h"
#include "ObjektGPU.h"
#include "Kamera.h"
#include "RGB.h"

class Pravac : public ObjektGPU
{
 public:
  __device__ __host__ Pravac() = default;
  __device__ __host__ Pravac(const Vektor4&,const Vektor3 &,RGB boja={255u,255u,255u});
  __device__ __host__ Pravac(const Vektor4&,const Vektor4&,RGB boja={255u,255u,255u});
   __device__ __host__ ~Pravac() = default;

   __device__ __host__ Pravac(const Pravac &) = default;
   __device__ __host__ Pravac & operator=(const Pravac &) = default;
   __device__ __host__ Pravac(Pravac &&) = default;
   __device__ __host__ Pravac & operator=(Pravac &&) = default;

        //void NamjestiOrtoSmjer(const Kamera &);

   __device__ __host__ void Transformiraj() override;

   __device__ bool PresijeciZraku(const Zraka &zraka,Realan &t) override;
   __device__ RGB Sjencaj(const Svjetlo svjetla[], size_t) override;

    protected:
    private:
    Vektor4 tocka;
    Vektor3 smjer;
    Vektor3 smjer2;
    RGB kd;
    static constexpr Realan debljina = 0.006f;
    //const double debljina = 0.02;
};
