#include "SDLIntegracija.h"
#include <iostream>

SDLIntegracija::SDLIntegracija(Uint32 opcije)
{
  if(SDL_Init(opcije) != 0)
    std::cout << "Greška u inicijalizaciji SDL-a!" << std::endl;
}

SDLIntegracija &SDLIntegracija::DajInstancu(Uint32 opcije)
{
  static SDLIntegracija instanca(opcije);
  return instanca;
}

/*
SDLIntegracija *SDLIntegracija::Pokreni(Uint32 opcije)
{
  if (!instanca)
    {
      instanca = new SDLIntegracija(opcije);
      return instanca;
    }

  else
    return nullptr;
}
*/

SDLIntegracija::~SDLIntegracija()
{
  SDL_Quit();
}
