#pragma once
#include "MatBaza.h"
#include "ObjektGPU.h"

class Sfera : public ObjektGPU
{
 private:
  Realan R;//radijus
  Realan reciprocR;
  Vektor3 kd = {1.0, 0, 0};
  //RGB kd = {255, 0, 0};//difuzna boja

 public:
  Sfera(Realan,RGB);
  explicit Sfera(Realan);
  Sfera() = default;
  virtual ~Sfera() = default;

  void Transformiraj() override;

  bool PresijeciZraku(const Zraka &zraka,Realan &t) override;
  //bool PresijeciZraku(const Kamera &,const Zraka &zraka,double &t) override;
  RGB Sjencaj(const std::forward_list<Svjetlo *> &) override;
};
