#pragma once
#include "MatBaza.h"
#include "Vektor3.h"
#include "Objekt.h"

class Trokut : public Objekt
{
 private:
  Vektor4 a, b, c;
  Vektor3 aTransformiran, bTransformiran, cTransformiran;
  Vektor3 transformiranaNormala, normala;
  //Vektor3 a, b, c;
  Vektor3 kd = {1.0, 0, 0};
  //RGB kd = {255, 0, 0};

 public:
  Trokut() = default;
  Trokut(const Vektor4 &,const Vektor4 &,const Vektor4 &, RGB);
  Trokut(const Vektor4 &,const Vektor4 &,const Vektor4 &);
  virtual ~Trokut() = default;

  void Transformiraj() override;

  bool PresijeciZraku(const Zraka &,Realan &) override;
  //bool PresijeciZraku(const Kamera &,const Zraka &,double &) override;
  RGB Sjencaj(const std::forward_list<Svjetlo *> &) override;
};
