#pragma once
#include "MatBaza.h"
#include "ObjektGPU.h"
#include "TrokutGPU.h"

class KvadarGPU : public ObjektGPU
{
    public:
        __device__ __host__ KvadarGPU() = default;
        __device__ __host__ KvadarGPU(Realan,Realan,Realan,RGB boja = {255u, 128u, 0u});
        __device__ __host__ ~KvadarGPU() = default;

	__device__ __host__ KvadarGPU(const KvadarGPU &) = default;
	__device__ __host__ KvadarGPU & operator=(const KvadarGPU &) = default;
	__device__ __host__ KvadarGPU(KvadarGPU &&) = default;
	__device__ __host__ KvadarGPU & operator=(KvadarGPU &&) = default;

        __device__ __host__ void Transformiraj() override;

        __device__ __host__ bool PresijeciZraku(const Zraka &zraka,Realan &t,int &presjecenTrokut, Vektor3 &sjeciste);
        //bool PresijeciZraku(const Kamera &,const Zraka &zraka,double &t) override;
        __device__ __host__ RGB Sjencaj(int presjecenTrokut, const Vektor3 &sjeciste, const Svjetlo[], size_t);
 protected:
 private:
	TrokutGPU t[12];//12 trokuta (6 stranica)
	//int presjecenTrokut = -1;
	Realan a, b, c;
	
	//Vektor3 kd = {1.0, 0.5, 0};
};
