#include "Zraka.h"

__device__ __host__ Zraka::Zraka(Vektor4 &ishodiste, Vektor4 &cilj)
{
  this->ishodiste = ishodiste.PerspektivnoDijeljenje();
  smjer = cilj.PerspektivnoDijeljenje() - this->ishodiste;
}

__device__ __host__ Zraka::Zraka(Vektor4 &ishodiste, Vektor3 &smjer)
{
  this->ishodiste = ishodiste.Radijusvektor();
  //  this->ishodiste = ishodiste.PerspektivnoDijeljenje();
  this->smjer = smjer;
}

__device__ __host__ Zraka::Zraka(Vektor3 &ishodiste, Vektor3 &smjer)
{
  this->ishodiste = ishodiste;
  this->smjer = smjer;
}
